<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
</head>

<body>

</body>

<script>
    ///////////////       Example 2               ///////////////
    //Tạo 1 class
    class Rectangle {
        //Hàm tạo(constructor)
        constructor(length, width) {
            this.length = length;
            this.width = width;
        }

        //Phương thức của class
        getArea() {
            return this.length * this.width;
        }
    }

    //Tạo class Square kế thừa class Rectangle
    class Square extends Rectangle {
        // constructor của class con
        constructor(length) {
            //Gọi đến constructor của class cha
            super(length, length);

        }

        //Phương thức của class con
        getPerimeter() {
            return 2 * (this.length + this.width);
        }
    }

    // Khởi tạo đối tượng  của class Rectangle
    let rectangle = new Rectangle(5, 10);
    //Tính diện tích hình chữ nhật
    console.log(rectangle.getArea()); // 50


    //Khởi tạo đối tượng của class Square
    let square = new Square(5);
    //Tinh chu vi
    console.log(square.getPerimeter()); //20
    //Tính diện tích hình vuông
    console.log(square.getArea()); //25



    //Kiểm tra xem đối tượng vừa tạo có đúng kiểu với class không ?
    console.log(square instanceof Square); //true
    console.log(square instanceof Rectangle); //true
    console.log(rectangle instanceof Square); // false
</script>

</html>